local L = AceLibrary("AceLocale-2.2"):new("OnlineCheck")

OCNameData = {}
OCAttData = {}
OCPerData = {}
OC7AttData = {}
OC7PerData = {}
OCRankData = {}
OCClassData = {}


local options = { 
    type='group',
    args = {
	hp = {
            type = 'text',
            name = 'Message',
            desc = 'Checks who in the current raid has below 10k HP',
            usage = "{self} display to self only",
	     input = boolean,
            get = false,
            set = "CheckHP",
        },	
	undo = {
            type = 'execute',
            name = 'Message',
            desc = 'Undo the check',
	     confirm = "Are you sure you want to undo the check? (This will discard all changes made this session)",
            func = "UndoCheck",
        },
	menu = {
            type = 'execute',
            name = 'Message',
            desc = 'Toggles menu',
            func = "Menu",
        },
	check = {
            type = 'execute',
            name = 'Message',
	     confirm = "Do you want to check who is online?",
            desc = 'Check who is online',
	     passValue = "1",
            func = "NumberOn",
        },
	recheck = {
            type = 'execute',
            name = 'Message',
	     confirm = "Do you want to recheck who is online? (This will discard the previous check)",
            desc = 'Recheck who is online',
	     passValue = "2",
            func = "NumberOn",
        },	
	reset = {
            type = 'execute',
            name = 'Message',
	     confirm = "Are you sure you want to reset the data?",
            desc = 'Reset the numbers',
            func = "Reset",
        },
	settime = {
            type = 'text',
            name = 'Sets the time of the daily check',
            desc = 'Sets the time of the daily check (Server Time)',
            usage = "{hour} {minute} (24 hr, server time)",
	     input = boolean,
            get = false,
            set = "SetTime",
        },
	show = {
            type = 'text',
            name = 'Show characters',
            desc = 'Displays the data for people online',
            usage = "{above/below/all} {value}",
	     input = boolean,
            get = false,
            set = "Display",
        },
	rank = {
            type = 'text',
            name = 'Minnimum Rank',
            desc = 'Sets the minnimum rank to be included in the checking',
            usage = "{help/set} {value}",
            get = "GetRank",
            set = "SetRank",
	},
        debug = {
            type = 'toggle',
            name = 'Debug Mode',
            desc = 'Toggles the debug mode',
            get = "IsDebug",
            set = "ToggleDebug",
        },

    },
}










OnlineCheck = AceLibrary("AceAddon-2.0"):new("AceEvent-2.0", "AceConsole-2.0", "AceDB-2.0")
OnlineCheck:RegisterChatCommand("/check", "/chk","/oc", options)
OnlineCheck:RegisterDB("OnlineCheckDB", "OnlineCheckDBPC")
OnlineCheck:RegisterDefaults("profile", {
    points = 0,
	QPlayer = {},
	QTotal = {},
	QPlayerT = {},
	QTotalT = {},
	TooMuch = 0,
	TooMuchCheck = 0,
	Debug = false,
	LastSevenChecks = { {} },
	LastSevenChecksTot = { {} },
	TLastSevenChecks = {},
	TLastSevenChecksTot = {},
} )

OnlineCheck:RegisterDefaults("char", {
    points = 0,
	MinRank = 10,
	LastCheck = 0,
	LastCheckTime = time(),
	hours = 0,
	minutes = 0,
	DailyCheck = false,
} )






------------------------------CALLED WHEN THE ADDON STARTS
function OnlineCheck:OnInitialize()
    -- Called when the addon is loaded
	
	GuildRoster()
	
	self.db.profile.TooMuch = self.db.profile.TooMuch + 1
	RosterCheck = 0
	RosterShow = 0
	CheckerFilter = 50
	ShowOffline = false
	GuildRoster()
	Chat_Output = ChatFrame_MessageEventHandler;
	ChatFrame_MessageEventHandler = Online_Event;
	OCTimeUpdate = time(); 		--For setting an update check offset

  	OCTimeFrame = CreateFrame("Frame");
  	OCTimeFrame:SetScript("OnUpdate", function() OnlineCheck:Time(); end); --CREATES A FRAME WHICH WILL UPDATE INDEFINATELY
	
	OCHours = self.db.profile.hours
	OCMinutes = self.db.profile.minutes

	

end
------------------------------------------------------------



------------------------------UPDATES THE ROSTER WHENEVER THE WORDS ONLINE OR OFFLINE ARE DETECTED (E.G. ??? HAS COME ONLINE)
function Online_Event(event)
if (string.find(arg1, "online") or string.find(arg1, "offline")) then
	OnlineCheck:Online_Event();
	GuildRoster()
end
Chat_Output(event)

end


function OnlineCheck:Online_Event()		--for some reason i had to call this function from the other one instead of just calling this one first
	if self.db.profile.Debug == true then
   	 	self:Print("Roster Updated")
	end
end
------------------------------------------------------------





------------------------------FUNCTIONS CALLED WHEN THE ADDON IS ENABLED OR DISABLED
function OnlineCheck:OnEnable()
    -- Called when the addon is enabled
end

function OnlineCheck:OnDisable()
    -- Called when the addon is disabled
end
------------------------------------------------------------










------------------------------TOGGLE THE SHOWING OF THE GUI
function OnlineCheck:Menu()
   if(  CheckerMenu:IsVisible() ) then
      CheckerMenu:Hide();
   else
      CheckerMenu:Show();
   end
end

------------------------------------------------------------








------------------------------FUNCTION USED BY THE ROSTER SCREEN TO SORT
function OCSortGuildRoster(text)
	SortGuildRoster(text)
	OnlineCheck:Display(OCtextdata)
	MyModScrollBar_Update()
end
------------------------------------------------------------






------------------------------FUNCTION CALLED TO SHOW THE NAMES OF THE CHARACTERS (NOW ADDS DATA TO BE USED BY THE TABLE)
function OnlineCheck:ShowName(name,rankIndex,rank,class)





if self.db.profile.Debug == true then
	self:Print("name","...","MinRank","...","rankIndex","...","RankName","...","Total") 		
	self:Print(name,"...",self.db.char.MinRank,"...",rankIndex+1,"...",GuildControlGetRankName(rankIndex+1),"...",self.db.profile.QTotal[name]) 		
end

if self.db.profile.TLastSevenChecks[name] == nil then
	self.db.profile.TLastSevenChecks[name] = 0
	self.db.profile.TLastSevenChecksTot[name] = 0
end

if tonumber(rankIndex) < tonumber(self.db.char.MinRank)  then
	OCj=OCj+1
	if self.db.profile.QTotal[name] == "0" then
		--self:Print(name," :",self.db.profile.QPlayer[name],"/",self.db.profile.QTotal[name],"( 0%)"); --Print the details about attendance
		OCNameData[OCj] = name
		OCAttData[OCj] = "0/0"
		OCPerData[OCj] = 0
		OCRankData[OCj] = rank
		OCClassData[OCj] = class
		OC7AttData[OCj] = "0/0"
		OC7PerData[OCj] = 0		
	else
		--self:Print(OCj,name," :",self.db.profile.QPlayer[name],"/",self.db.profile.QTotal[name],"(",ceil(self.db.profile.QPlayer[name]/self.db.profile.QTotal[name]*100),"%)"); --Print the details about attendance
		OCNameData[OCj] = name
		OCAttData[OCj] = self.db.profile.QPlayer[name].."/"..self.db.profile.QTotal[name]
		OCPerData[OCj] = ceil(self.db.profile.QPlayer[name]/self.db.profile.QTotal[name]*100)
		OCRankData[OCj] = rank
		OCClassData[OCj] = class
		OC7AttData[OCj] = self.db.profile.TLastSevenChecks[name].."/"..self.db.profile.TLastSevenChecksTot[name]
		OC7PerData[OCj] =  ceil(self.db.profile.TLastSevenChecks[name]/self.db.profile.TLastSevenChecksTot[name]*100)
	end
end
end
------------------------------------------------------------



------------------------------THE FUNCTION USED BY THE XML SLIDER TO DETERMINE THE FILTER VALUE
function OnlineCheck:filter(value)
CheckerFilter = value
--	self:Print(value) 		--debugging
--	self:Print("Done")		--debugging
end
------------------------------------------------------------



------------------------------THE FUNCTION WHICH CALCULATES AND DISPLAYS WHEN YOU LAST CHECKED WHO WAS ONLINE
function OnlineCheck:LastCheck()
local ocday, ochour, ocmin, ocsec
local LastCheckTime = time()-self.db.char.LastCheckTime
ocday = 0
ochour = 0
ocmin = 0
ocsec = 0

self:Print( "Last Check: ".. self.db.char.LastCheck )

for i=1, 30 do
	if LastCheckTime > 60*60*24 then
		ocday = ocday + 1
		LastCheckTime = LastCheckTime - 60*60*24
	end
end

for i=1, 24 do
	if LastCheckTime > 60*60 then
		ochour = ochour + 1
		LastCheckTime = LastCheckTime - 60*60
	end
end

for i=1, 60 do

	if LastCheckTime > 60 then
		ocmin = ocmin + 1
		LastCheckTime = LastCheckTime - 60
	end
end

self:Print(ocday,"Days",ochour,"Hrs", ocmin,"Min", LastCheckTime,"Sec Ago")

end
------------------------------------------------------------





------------------------------THE SHOW COMMAND SHOWS WHO IS ONLINE (with filtering) (/SHOW COMMAND)
function OnlineCheck:Display(text)
OCtextdata = text
OCj = 0

------------------------------Taken from QDKP_V2 created by thebreaker1205
------------------------------http://wow.curse.com/downloads/details/5124/
local Words=WordParser(text) --get a list of the word of the command, lowcased
  
local W1=Words[1]
local W2=Words[2]

local compcheck = 0		--used to know if the right command was entered

SetGuildRosterShowOffline()
if self.db.profile.Debug == true then
	self:Print(W1,"...",W2) 			--Debugging, shows the commands passed to the function
end

for i=1, GetNumGuildMembers() do
	local name, rank, rankIndex, level, class, zone, note, officernote, online, status  = GetGuildRosterInfo(i)
	if level == 70 then
		if self.db.profile.QPlayer[name] == nil then
			self.db.profile.QPlayer[name] = "0"
		end

		if self.db.profile.QTotal[name] == nil then
			self.db.profile.QTotal[name] = "0"		
		end

		if online == 1 or ShowOffline == true then
			local filter = tonumber(ceil(self.db.profile.QPlayer[name]/self.db.profile.QTotal[name]*100))
			if W1 == "all" then
				OnlineCheck:ShowName(name,rankIndex,rank,class)
				compcheck = 1
			elseif W1 == "above" or W1 == "a" and W2 ~= nil then
				if filter >= tonumber(W2) then
					OnlineCheck:ShowName(name,rankIndex,rank,class)	
				end
				compcheck = 1
			elseif W1 == "below" or W1 == "b" and W2 ~= nil then
				if self.db.profile.QPlayer[name] == "0" or filter < tonumber(W2) then
					OnlineCheck:ShowName(name,rankIndex,rank,class)
				end
				compcheck = 1
			end		
		end
	
	end
CheckerMainFrame:Show()
MyModScrollBar_Update()
end


if compcheck == 1 then
	--self:Print("Scan Complete")
else
	self:Print("Command not recognized/No eligable characters online")
end

end
------------------------------------------------------------














------------------------------CHECKS WHO IS ONLINE (/CHECK COMMAND)
function OnlineCheck:NumberOn(RosterCheck)  			--Allows us to check who is online

GuildRoster()
--self:Print(RosterCheck)		--debugging


if RosterCheck == "1" or RosterCheck == "2" then
	if self.db.profile.TooMuchCheck == self.db.profile.TooMuch and RosterCheck ~= "2" then
		self:Print("You have already checked who is online this session")
	else
		SetGuildRosterShowOffline() --show offline ppl

		for i=1, GetNumGuildMembers() do
			local name, rank, rankIndex, level, class, zone, note, officernote, online, status  = GetGuildRosterInfo(i)
			


			for i=1,7 do
				if self.db.profile.LastSevenChecks[i][name] == nil then
					self.db.profile.LastSevenChecks[i][name] = 0
					self.db.profile.LastSevenChecksTot[i][name] = 0
				end
				self.db.profile.LastSevenChecks[9-i][name] = self.db.profile.LastSevenChecks[8-i][name]
				self.db.profile.LastSevenChecksTot[9-i][name] = self.db.profile.LastSevenChecksTot[8-i][name]
			end					
			
			
			
			

			if RosterCheck == "1" or self.db.profile.TooMuchCheck ~= self.db.profile.TooMuch then
				self.db.profile.QPlayerT[name] = self.db.profile.QPlayer[name]
				self.db.profile.QTotalT[name] = self.db.profile.QTotal[name]
			end

			--self:Print(name,level,i);
			if level == 70 and online == 1 and rankIndex < tonumber(self.db.char.MinRank) then
				if self.db.profile.QTotalT[name] == nil  then   --if there is no value then assign the value 1
					self.db.profile.QPlayer[name] = 1
					self.db.profile.QTotal[name] = 1

				else					--if there is a value then increment it
					self.db.profile.QPlayer[name] = self.db.profile.QPlayerT[name] + 1
					self.db.profile.QTotal[name] = self.db.profile.QTotalT[name] + 1
				end

				self.db.profile.LastSevenChecks[1][name] = 1
				self.db.profile.LastSevenChecksTot[1][name] = 1

				if self.db.profile.Debug == true then
					OnlineCheck:ShowName(name,rankIndex,rank,class)
				end
			elseif level == 70 and online ~= 1 and rankIndex < tonumber(self.db.char.MinRank) then
				if self.db.profile.QTotalT[name] == nil  then 		--if they are not oline dont increment the number
					self.db.profile.QTotal[name] = 1
					self.db.profile.QPlayer[name] = 0
				else					--if they are not oline dont increment the number
					self.db.profile.QTotal[name] = self.db.profile.QTotalT[name] + 1
				end

				self.db.profile.LastSevenChecks[1][name] = 0
				self.db.profile.LastSevenChecksTot[1][name] = 1
			end

			self.db.profile.TLastSevenChecks[name] = 0
			self.db.profile.TLastSevenChecksTot[name] = 0

			if self.db.profile.Debug == true then
				self:Print("name" , "i" , " tot" , "checks")
			end

			for i=1,7 do
				self.db.profile.TLastSevenChecks[name] = self.db.profile.TLastSevenChecks[name] + self.db.profile.LastSevenChecks[i][name]
				self.db.profile.TLastSevenChecksTot[name] = self.db.profile.TLastSevenChecksTot[name] + self.db.profile.LastSevenChecksTot[i][name]
				if self.db.profile.Debug == true then
					self:Print(name , i ,  "       " , self.db.profile.TLastSevenChecks[name] ,"/", self.db.profile.TLastSevenChecksTot[name] , "       " ,  self.db.profile.LastSevenChecks[i][name],"/",self.db.profile.LastSevenChecksTot[i][name])
				end
			end

		end
	self.db.char.LastCheck = date()
	self.db.char.LastCheckTime = time()
	self:Print("Check Complete")
	self.db.profile.TooMuchCheck = self.db.profile.TooMuch
	end
end	--End if RosterCheck
end	--End function GUILD_ROSTER_UPDATE
------------------------------------------------------------





------------------------------UNDO THE CHECK CARRIED OUT
function OnlineCheck:UndoCheck()
if self.db.profile.TooMuchCheck ~= self.db.profile.TooMuch then
	self:Print("You have not checked the characters online this session")
else
	for i=1, GetNumGuildMembers() do
		local name, rank, rankIndex, level, class, zone, note, officernote, online, status  = GetGuildRosterInfo(i)
		self.db.profile.QPlayer[name] = self.db.profile.QPlayerT[name]
		self.db.profile.QTotal[name] = self.db.profile.QTotalT[name]
		self.db.profile.TooMuch = self.db.profile.TooMuch + 1
	end
	self:Print("Undo Complete")
end
end
------------------------------------------------------------



------------------------------FUNCTION TO RESET THE NUMBERS
function OnlineCheck:Reset()
       mynum=GetNumGuildMembers(offline) --The number of ppl online atm
       self:Print("Numbers Reset")

	SetGuildRosterShowOffline() --Show offline ppl
	
	for i=1, GetNumGuildMembers() do
		local name, rank, rankIndex, level, class, zone, note, officernote, online, status  = GetGuildRosterInfo(i)
		if level == 70 then
			self.db.profile.QPlayer[name] = 0
			self.db.profile.QTotal[name] = 0		
		end
	end
end
------------------------------------------------------------




------------------------------TOGGLES THE SHOWING OF OFFLINE CHARACTERS
function OnlineCheck:ShowOffline()
ShowOffline = not ShowOffline
if ShowOffline == true then
	self:Print("ENABLED Offline players will now be displayed. (Press ''Show Offline'' again to turn this option off)")
else
	self:Print("DISABLED Offline players will not be displayed. (Press ''Show Offline'' again to turn this option on)")
end
end
------------------------------------------------------------



------------------------------POPUP MENU FOR CHOOSING THE MIN RANK TO BE FILTERED IN
function MinRankPopup()
OnlineCheck:ChangeMinRank("0")
   if(  MinRankMenu:IsVisible() ) then
      MinRankMenu:Hide();
   else
      MinRankMenu:Show();
   end

end
------------------------------------------------------------


------------------------------POPUP MENU FOR CHOOSING THE CHECK TIME
function CheckTimePopup()
OnlineCheck:SetTime("nil")
   if(  CheckTimeMenu:IsVisible() ) then
      CheckTimeMenu:Hide();
   else
      CheckTimeMenu:Show();
   end

end
------------------------------------------------------------



------------------------------RETRIVES THE DEBUG MODE SETTING
function OnlineCheck:IsDebug()
return self.db.profile.Debug
end
------------------------------------------------------------



------------------------------TOGGLES DEBUG MODE
function OnlineCheck:ToggleDebug()
self.db.profile.Debug = not self.db.profile.Debug
end
------------------------------------------------------------



------------------------------RETRIVES THE MIN RANK FOR FILTERING
function OnlineCheck:GetRank()
return GuildControlGetRankName(self.db.char.MinRank)
end
------------------------------------------------------------




------------------------------CHANGES THE MIN RANK (NOT THE SLASH COMMAND)
function OnlineCheck:ChangeMinRank(value)
if value == "0" then
	--self:Print("Currently set to rank " .. self.db.char.MinRank .. " (" .. GuildControlGetRankName(self.db.char.MinRank) .. ")")
elseif value == "1" then
	self.db.char.MinRank = self.db.char.MinRank - 1
	self:Print("Set to rank " .. self.db.char.MinRank .. " (" .. GuildControlGetRankName(self.db.char.MinRank) .. ")")
elseif value == "2" then
	self.db.char.MinRank = self.db.char.MinRank + 1
	self:Print("Set to rank " .. self.db.char.MinRank .. " (" .. GuildControlGetRankName(self.db.char.MinRank) .. ")")
end

getglobal("OCRank"):SetText(self.db.char.MinRank .. " (" .. GuildControlGetRankName(self.db.char.MinRank) .. ")");
end
------------------------------------------------------------









------------------------------SETS THE MIN RANK FOR FILTERING (SLASH COMMAND)
function OnlineCheck:SetRank(text)
--------------------Taken from QDKP_V2 created by thebreaker1205
--------------------http://wow.curse.com/downloads/details/5124/
local Words=WordParser(text) --get a list of the word of the command, lowcased
  
local W1=Words[1]
local W2=Words[2]
self:Print(W1,"...",W2,"...",GuildControlGetNumRanks())
	if W1 == "help" then
		for i=1,GuildControlGetNumRanks() do
			self:Print(" Number: ",i,"Rank: ",GuildControlGetRankName(i))
		end
	elseif W1 == "set" and W2 ~= nil then
		self.db.char.MinRank = W2
	end

end
------------------------------------------------------------




------------------------------FUNCTIONS THAT HANDLE THE MONITORING OF TIME CHANGING (FOR THE DAILY CHECK)
function OnlineCheck:Time()

if time() > OCTimeUpdate + 40 and OCDailyScanCheck ~= "1" then
	OnlineCheck:Time2()
	OCTimeUpdate = time()
end

end


function OnlineCheck:Time2()

local hours,minutes = GetGameTime();

if hours == self.db.profile.hours and minutes == self.db.profile.minutes and self.db.profile.DailyCheck == true then
	StaticPopup_Show ("OCAlarm");
	OCDailyScanCheck = "1"
end

if self.db.profile.Debug == true then
	if hours ~= hours2 or minutes ~= minutes2 then
		if hours < 10 then
			if minutes < 10 then
				self:Print("Time","0"..hours..":".."0"..minutes)
			else
				self:Print("Time","0"..hours..":"..minutes)
			end
		else
			if minutes < 10 then
				self:Print("Time",hours..":".."0"..minutes)
			else
				self:Print("Time",hours..":"..minutes)
			end
		end
	end
end
hours2 = hours
minutes2 = minutes
end
------------------------------------------------------------




------------------------------FUNCTION FOR SETTING THE DAILY CHECK TIME
function OnlineCheck:SetTime(text)


if text == "show" then
	self:Print("Check time currently set to ->", self.db.profile.hours, ":", self.db.profile.minutes)
elseif text == "toggle" then
	self.db.profile.DailyCheck = not self.db.profile.DailyCheck
	if self.db.profile.DailyCheck then
		self:Print("Daily check enabled");
	else
		self:Print("Daily check disabled");
	end
else
	local Words=WordParser(text) --get a list of the word of the command, lowcased
	local W1=Words[1]
	local W2=Words[2]
	if W1 ~= nil and W2 ~= nil then
		if tonumber(W1) > 0 and tonumber(W1) < 99 and tonumber(W2) > 0 and tonumber(W2) < 99 then
			self.db.profile.hours = tonumber(W1)
			OCHours = tonumber(W1)		--used by the GUI
			self.db.profile.minutes = tonumber(W2)
			OCMinutes = tonumber(W2)	--used by the GUI
			self.db.profile.DailyCheck = true
			OCDailyScanCheck = "0"
			self:Print("Check time set to ->",self.db.profile.hours,":",self.db.profile.minutes)
		end
	end
end
getglobal("OCCheckTime"):SetText(self.db.profile.hours .. ":" .. self.db.profile.minutes);

end
------------------------------------------------------------






















------------------------------CODE BORROWED FROM ANOTHER ADDON
------------------------------Taken from QDKP_V2 created by thebreaker1205
------------------------------http://wow.curse.com/downloads/details/5124/
function WordParser(text)
  local start=1
  local output={}
  for i=1,string.len(text) do
    if string.sub(text,i,i)==" " then
      table.insert(output,string.lower(string.sub(text,start,i-1)))
      start=i+1
    end
  end
  table.insert(output,string.lower(string.sub(text,start,string.len(text))))
  return output
end
------------------------------------------------------------




------------------------------FUNCTION FOR CHECKING WHO HAS BELOW 10K HP
function OnlineCheck:CheckHP(text)
local total = 0
if text == "self" then
	DEFAULT_CHAT_FRAME:AddMessage("Players with less than 10k HP:");
else
	SendChatMessage("Players with less than 10k HP:", "RAID", nil, nil);
end
for i=1,40 do
	local name, rank, rankIndex, level, class, zone, note, officernote, online, status  = GetRaidRosterInfo(i)
	local max_health = 0
	if UnitInRaid(name) then
		max_health = UnitHealthMax(name);

		if self.db.profile.Debug == true then
   	 		self:Print(name,max_health)
		end

		if max_health < 10000 then
			if text == "self" then
				total = total + 1
				local s = total .. ": " .. name .. " (" .. max_health .. ")"
				DEFAULT_CHAT_FRAME:AddMessage(s);
			else
				total = total + 1
				local s = total .. ": " .. name .. " (" .. max_health .. ")"
				SendChatMessage(s, "RAID", nil, nil);
				local s = "Your HP is below 10k. You need another " .. 10000 - max_health .. " HP"
				SendChatMessage(s, "WHISPER", nil, name);
			end
		end
	end
end
if total == 0 then
	SendChatMessage("None", "RAID", nil, nil);
end
end
------------------------------------------------------------


function OnlineCheck:OCEditName(val)

OCClass = strupper(OCClassData[OClineplusoffset+ val - 15])
OCRed = RAID_CLASS_COLORS[OCClass].r
OCGreen = RAID_CLASS_COLORS[OCClass].g
OCBlue = RAID_CLASS_COLORS[OCClass].b
OCClassColor = "|c" .. RGBtoHex(OCRed,OCGreen,OCBlue)

OCAttColor = OCSetWarnColor( OCPerData[OClineplusoffset+ val - 15] )
OC7AttColor = OCSetWarnColor( OC7PerData[OClineplusoffset+ val - 15] )


if self.db.profile.Debug == true then
	DEFAULT_CHAT_FRAME:AddMessage(val);
	DEFAULT_CHAT_FRAME:AddMessage(OClineplusoffset);
	DEFAULT_CHAT_FRAME:AddMessage(OClineplusoffset + val - 15);

end

DEFAULT_CHAT_FRAME:AddMessage("-------------------------------------------")
DEFAULT_CHAT_FRAME:AddMessage("Name: " .. OCNameData[OClineplusoffset+ val - 15]);
DEFAULT_CHAT_FRAME:AddMessage("Class: " .. OCClassColor .. OCClassData[OClineplusoffset+ val - 15]);
DEFAULT_CHAT_FRAME:AddMessage("Rank: " .. OCRankData[OClineplusoffset+ val - 15]);
DEFAULT_CHAT_FRAME:AddMessage("Total Attendence: " .. OCAttColor .. OCAttData[OClineplusoffset+ val - 15]);
DEFAULT_CHAT_FRAME:AddMessage("Total Percentage: " .. OCAttColor .. OCPerData[OClineplusoffset+ val - 15] .. "%");
DEFAULT_CHAT_FRAME:AddMessage("Last 7 Checks Attendence: " .. OC7AttColor .. OC7AttData[OClineplusoffset+ val - 15]);
DEFAULT_CHAT_FRAME:AddMessage("Last 7 Checks Percentage: " .. OC7AttColor .. OC7PerData[OClineplusoffset+ val - 15] .. "%");
DEFAULT_CHAT_FRAME:AddMessage("-------------------------------------------")

--      getglobal("OCSingleName"):SetText("|cFF"..ClassColor..OCNameData[OClineplusoffset].."|r");

end



-----------------------------Converts RGB to hex
function RGBtoHex(r,g,b)
	return string.format("%2x%2x%2x%2x", 255, r*255, g*255, b*255);
end



function OCSetWarnColor(value)

--value = tonumber(value)

	if value == nil then
		return "|cFFFFFFFF"
	elseif value >= 0 and value <= 20 then
		return "|cFFFF0000"
	elseif value > 20 and value <= 40 then
		return "|cFFFF7F00"
	elseif value > 40 and value <= 60 then
		return "|cFFFFF569"
	elseif value > 60 then
		return "|cFF00FF00"
	else
		return "|cFFFF0000"
	end
end


------------------------------FUNCTION FOR UPDATING THE ROSTER GUI
function MyModScrollBar_Update()
  local line; -- 1 through 5 of our window to scroll
--  local OClineplusoffset; -- an index into our data calculated from the scroll offset
  FauxScrollFrame_Update(MyModScrollBar,OCj-10 ,5,16);
  for line=1,15 do
    OClineplusoffset = line + FauxScrollFrame_GetOffset(MyModScrollBar);


--Sets class colors
if OCClassData[OClineplusoffset] ~= nil then

	OCClass = strupper(OCClassData[OClineplusoffset])
	OCRed = RAID_CLASS_COLORS[OCClass].r
	OCGreen = RAID_CLASS_COLORS[OCClass].g
	OCBlue = RAID_CLASS_COLORS[OCClass].b
	OCClassColor = "|c" .. RGBtoHex(OCRed,OCGreen,OCBlue)

end



--Set warning colors

AttColor = OCSetWarnColor(OCPerData[OClineplusoffset])
Att7Color = OCSetWarnColor(OC7PerData[OClineplusoffset])



    if OClineplusoffset <= OCj then
      getglobal("OCName"..line):SetText(OCClassColor..OCNameData[OClineplusoffset].."|r");
      getglobal("OCAtt"..line):SetText(AttColor..OCAttData[OClineplusoffset].."|r");
      getglobal("OCPer"..line):SetText(AttColor..OCPerData[OClineplusoffset].."%".."|r");
      getglobal("OC7Att"..line):SetText(Att7Color..OC7AttData[OClineplusoffset].."|r");
      getglobal("OC7Per"..line):SetText(Att7Color..OC7PerData[OClineplusoffset].."%".."|r");
      getglobal("OCRank"..line):SetText(OCClassColor..OCRankData[OClineplusoffset].."|r");
      getglobal("OCClass"..line):SetText(OCClassColor..OCClassData[OClineplusoffset].."|r");

      getglobal("OCName"..line):Show();
      getglobal("OCAtt"..line):Show();
      getglobal("OCPer"..line):Show();
      getglobal("OC7Att"..line):Show();
      getglobal("OC7Per"..line):Show();
      getglobal("OCRank"..line):Show();
      getglobal("OCClass"..line):Show();
    else
      getglobal("OCName"..line):Hide();
      getglobal("OCAtt"..line):Hide();
      getglobal("OCPer"..line):Hide();
      getglobal("OC7Att"..line):Hide();
      getglobal("OC7Per"..line):Hide();
      getglobal("OCRank"..line):Hide();
      getglobal("OCClass"..line):Hide();

    end
  end
end
------------------------------------------------------------